% Using the estimated threshold of the minimum possible distance between
% a discord and its nearest neighbor, detect the potential discords and
% place them into main memory.
function [MM, indxPtr, MMvolume] = buildMainMemory(DB, threshold, oldMM, oldindxPtr, newoffset)
    MM = [];
    indxPtr = [];
    MMvolume = [];
    checkAll = true;
    offset = 0;
    if (nargin > 2)
        MM = oldMM;
        indxPtr = oldindxPtr;
        page_num = 0;
        offset = newoffset;
    end;
    for i = 1:size(DB,1)
        pruningIndices = pruned(DB(i,:), MM, threshold, checkAll); % which time series in MM has pruned the current example, -1 if none
        indsToKeep = find(pruningIndices == -1);
        if (size(indsToKeep,1) == size(MM,1))
            MM = [MM;DB(i,:)];
            indxPtr = [indxPtr; (i+offset)];
        else 
            MM = MM(indsToKeep,:);
            indxPtr = indxPtr(indsToKeep);
        end;            
        MMvolume = [MMvolume; size(MM,1)]; 
    end;
    
function Indx = pruned(Xi, MM, threshold, checkAll)
    Indx = -1*ones(size(MM,1),1);
    for i = 1:size(MM,1)
        tmpDist = computeDist(Xi, MM(i,:));
        if (tmpDist < threshold)
            if (checkAll)
                Indx(i,1) = 1;
            else
                Indx(i,1) = 1;
                return;
            end;
        end;
    end;
    