% Performs a second pass through the memory to remove elements that are not
% actual discords.
function [MMem, indxPtrMem] = cleanMainMemory(DB, threshold, MM, indxPtr)
    MMem = MM;
    indxPtrMem = indxPtr;
    for i = 1:size(DB,1)
        inds = find(indxPtr == i);
        if (size(inds,1) == 0)
            indxs = pruned(DB(i,:), MMem, threshold, true);
            keepInMem = find(indxs == -1);
            if (size(keepInMem,1) ~= size(MMem,1))
                MMem = MMem(keepInMem,:);
                indxPtrMem = indxPtrMem(keepInMem,:);
            end;
        end;
    end;

function Indx = pruned(Xi, MM, threshold, checkAll)
    Indx = -1*ones(size(MM,1),1);
    for i = 1:size(MM,1)
        tmpDist = computeDist(Xi, MM(i,:));
        if (tmpDist < threshold)
            if (checkAll)
                Indx(i,1) = 1;
            else
                Indx(i,1) = 1;
                return;
            end;
        end;
    end;
    