% Given a data set DB and samplePerc, extracts a random subset of size
% (samplePerc/100)*size(DB,1) and finds the distribution of the NN distances
% in this subsample. Based on it, a pruning threshold is computed
function T = computeThreshold(DB, samplePerc)    
    N = size(DB,1);
    %choose ~ samplePerc elements from the DB
    rndInds = [];
    for i = 1:size(DB,1);
        x = round((100/samplePerc) * rand(1));
        if (x == 0)
            rndInds = [rndInds;i];
        end;
    end;
    rndSample = DB(rndInds, :);
    %size(rndSample)
    % find the discord
    minMaxDist = 0;
    minMaxDists = zeros(size(rndSample,1),1);
    for i = 1:size(rndSample,1)
        tmpMinMaxDist = nnDist(rndSample(i,:), i, rndSample);
        if (tmpMinMaxDist > minMaxDist) 
            minMaxDist = tmpMinMaxDist;
        end;
        minMaxDists(i,1) = tmpMinMaxDist;
    end;
    %T = minMaxDist;
    hist(minMaxDists, 0:1:40);
    T = mean(minMaxDists) + std(minMaxDists);