% Computes the nearest neighbor distance from X to any element of DB 
% if X is in DB, then indxX is its index. This is necessary so that 
% it can be ignored from consideration, otherwise it will be returned as 
% nearest neighbor to itself.
function [D, inds] = nnDist(x, indxX, DB)
    minDist = realMax;
    inds = 0;
    for i = 1:size(DB,1)
        if (i == indxX)
            continue;
        end;
        % todo: Do earlyAbandon
        tmpMinDist = computeDist(x, DB(i,:));
        if (tmpMinDist < minDist)
            minDist = tmpMinDist;            
            inds = i;
        end;
    end;
    D = minDist;